////////////////////////////////////////////////////////////////////
// Uq^V~[V
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <direct.h>
#include <stdlib.h>
#include "Vector3.h"
#include "RK4.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//
double T = 100.0;
//̍
const int N = 100;

//͈̔
double t_min = 0;
double t_max = 50;
double dt = 0.001;
//d͉x
double g = 10.0;
//
double m = 1.0;
//Ђ̒
double L = 1.0;
//x_̍
double z_box = L;

//ŮpU
double omega_box = sqrt( g / L );//[rad/s]
//U̐U
double l = 0.1;

//␳p[^
double compensationK = 0.0; //␳΂˒eW
double compensationGamma = 0.0; //␳SRW

int NN = round((t_max - t_min) / dt);
int skip = 50;
////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particle : public RK4 {
private:
public:
	//Uq̊pU
	double Bn[N + 1] = { 0.0 };

	//RXgN^
	Particle() {}
	Particle(double _dt) {
		dt = _dt;
	}
	Particle(double _dt, Vector3& _r, Vector3& _v) {
		dt = _dt;
		r.copy(_r);
		v.copy(_v);
	}
	//x_̈ʒuxNgExxNgExxNg
	Vector3 r_box_function(double t) {
		Vector3 r_box(0, 0, z_box);

		for (int n = 1; n <= N; n++) {
			r_box.x += l * Bn[n] * sin(2.0 * M_PI * n / T * t);
		}

		return r_box;
	};
	Vector3 v_box_function(double t) {
		Vector3 v_box(0, 0, 0);
		for (int n = 1; n <= N; n++) {
			v_box.x += l * Bn[n] * 2.0 * M_PI * n / T * cos(2.0 * M_PI * n / T * t);
		}
		return v_box;
	};
	Vector3 a_box_function(double t) {
		Vector3 a_box(0, 0, 0);
		for (int n = 1; n <= N; n++) {
			a_box.x += -l * Bn[n] * pow(2.0 * M_PI * n / T, 2) * sin(2.0 * M_PI * n / T * t);
		}
		return a_box;
	};
	//͂̑傫
	double S(double t, Vector3 r, Vector3  v) {
		Vector3 r_box = r_box_function(t);
		Vector3 v_box = v_box_function(t);
		Vector3 a_box = a_box_function(t);
		Vector3 vecL = r - r_box;
		Vector3 vecV = v - v_box;
		return -m * (vecV.lengthSq() - a_box.dot(vecL) - g * vecL.z) / (L * L);
	};
	//xxNgiK{j
	Vector3 A(double t, Vector3& r, Vector3& v) {
		Vector3 r_box = r_box_function(t);
		Vector3 v_box = v_box_function(t);
		Vector3 a_box = a_box_function(t);

		Vector3 f;
		f.x = S(t, r, v) / m * (r.x - r_box.x);
		f.y = S(t, r, v) / m * (r.y - r_box.y);
		f.z = -g + S(t, r, v) * (r.z - r_box.z);

		//␳
		Vector3 _L = r - r_box;
		//std::cout << L - _L.length() << std::endl;

		Vector3 hatL = _L.clone().normalize();
		//␳΂˒e
		Vector3 fk = hatL.clone() * (-compensationK * (L - _L.length()));
		//x␳
		Vector3 barV = v - v_box;
		//␳SR
		Vector3 fgamma = hatL.clone() * (-compensationGamma * barV.dot(hatL));

		f += fk + fgamma;

		return f;
	};
};

double maxEnergy(double* Bn) {

	//QNb^IuWFNg̐
	Particle particle(dt);
	//ʒuxNgƑxxNg
	particle.r.set(0, 0, 0);
	particle.v.set(0, 0, 0);

	for (int i = 0; i <= N; i++) {
		particle.Bn[i] = Bn[i];
	}

	double maxE = 0;
	int NN = round((t_max - t_min) / dt);
	for (int i = 0; i <= NN; i++) {
		double t = i * dt;

		double E = 1.0 / 2.0 * m * particle.v.lengthSq() + m * g * particle.r.z;
		if (maxE < E) maxE = E;

		//QENb^@ɂ鎞ԔW
		particle.timeEvolution(t);

		//ʒu̍XV
		particle.r = particle.r + particle.dr;
		//x̍XV
		particle.v = particle.v + particle.dv;

		Vector3 r_box_last = particle.r_box_function(t);
		double _L = Vector3::distance(r_box_last, particle.r);

		if (i % 100 == 0)std::cout << " E= " << E << "  " << "L=" << _L - L << std::endl;

	}
	return maxE;
}
void locus(double* Bn, Vector3* out_r, Vector3* out_v) {

	//QNb^IuWFNg̐
	Particle particle(dt);
	//ʒuxNgƑxxNg
	particle.r.set(0, 0, 0);
	particle.v.set(0, 0, 0);

	for (int i = 0; i <= N; i++) {
		particle.Bn[i] = Bn[i];
	}

	for (int i = 0; i <= NN; i++) {
		double t = i * dt;

		if (i%skip == 0) {
			out_r[i / skip].copy(particle.r);
			out_v[i / skip].copy(particle.v);
		}

		//QENb^@ɂ鎞ԔW
		particle.timeEvolution(t);

		//ʒu̍XV
		particle.r = particle.r + particle.dr;
		//x̍XV
		particle.v = particle.v + particle.dv;

	}
}

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {

	//tH_̐
	_mkdir("output");

	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/ForcedVibrationSinglePendulumMotion_RK.txt";
	// t@Co̓Xg[̏
	std::ofstream ofs(filename.str());

	ofs << "#x:" << std::endl;
	//ofs << "#y:zW" << std::endl;
	ofs << "#legend: zW ͊wGlM[/10" << std::endl;
	ofs << "#showLines: true true true true true true" << std::endl;
	ofs << "#showMarkers: false false false false false false" << std::endl;
	ofs << "#fills: false false false false false false" << std::endl;
	ofs << "#xrange:" << 0 << " " << t_max << " " << t_max/10 << std::endl;
	ofs << "#yrange:" << 0 << " " << L * 2 << " " << 2 * L/10 << std::endl;

	//WJW
	double Bn[N + 1] = { 0.0 };

	Bn[50] = 0.5;
	Bn[10] = 1.0;
	double energy = maxEnergy(Bn);
	std::cout << "E=" << energy << std::endl;

	Vector3 *r, *v;
	r = new Vector3[NN / skip + 1];
	v = new Vector3[NN / skip + 1];
	locus( Bn, r, v );

	for (int i = 0; i <= NN / skip; i++) {
		double time = dt * skip * i;
		double energy = 1.0/2.0 * m * v[i].lengthSq() + m * g * r[i].z;

		ofs << time << " " << r[i].z << " " << energy / 10.0 << std::endl;
		//std::cout << "t =" << time << " ";
		//std::cout << "r=(" << r[i].x << "," << r[i].y << "," << r[i].z << ")" << " ";
		//std::cout << "v=(" << v[i].x << "," << v[i].y << "," << v[i].z << ")" << std::endl;
	}

	ofs.close();

	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;
}

